import createBaseMonitoring from '@resolve-js/monitoring-base';
import getLog from '@resolve-js/debug-levels';
import { monitoringPublish } from './publish';

const createMonitoringImplementation = (log, context, {
  baseMonitoring
}) => ({
  group: config => createMonitoringImplementation(log, context, {
    baseMonitoring: baseMonitoring.group(config)
  }),
  duration: baseMonitoring.duration.bind(baseMonitoring),
  error: baseMonitoring.error.bind(baseMonitoring),
  time: baseMonitoring.time.bind(baseMonitoring),
  timeEnd: baseMonitoring.timeEnd.bind(baseMonitoring),
  publish: monitoringPublish.bind(null, log, context),
  execution: baseMonitoring.execution.bind(baseMonitoring),
  rate: baseMonitoring.rate.bind(baseMonitoring),
  getMetrics: baseMonitoring.getMetrics.bind(baseMonitoring),
  clearMetrics: baseMonitoring.clearMetrics.bind(baseMonitoring),
  custom: baseMonitoring.custom.bind(baseMonitoring)
});

const createMonitoring = ({
  publishMode = 'processExit'
} = {}) => {
  const baseMonitoring = createBaseMonitoring();
  return createMonitoringImplementation(getLog('resolve:monitoring-console'), {
    baseMonitoring,
    publishMode
  }, {
    baseMonitoring
  });
};

export default createMonitoring;
//# sourceMappingURL=index.js.map