"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _monitoringBase = _interopRequireDefault(require("@resolve-js/monitoring-base"));

var _debugLevels = _interopRequireDefault(require("@resolve-js/debug-levels"));

var _publish = require("./publish");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const createMonitoringImplementation = (log, context, {
  baseMonitoring
}) => ({
  group: config => createMonitoringImplementation(log, context, {
    baseMonitoring: baseMonitoring.group(config)
  }),
  duration: baseMonitoring.duration.bind(baseMonitoring),
  error: baseMonitoring.error.bind(baseMonitoring),
  time: baseMonitoring.time.bind(baseMonitoring),
  timeEnd: baseMonitoring.timeEnd.bind(baseMonitoring),
  publish: _publish.monitoringPublish.bind(null, log, context),
  execution: baseMonitoring.execution.bind(baseMonitoring),
  rate: baseMonitoring.rate.bind(baseMonitoring),
  getMetrics: baseMonitoring.getMetrics.bind(baseMonitoring),
  clearMetrics: baseMonitoring.clearMetrics.bind(baseMonitoring),
  custom: baseMonitoring.custom.bind(baseMonitoring)
});

const createMonitoring = ({
  publishMode = 'processExit'
} = {}) => {
  const baseMonitoring = (0, _monitoringBase.default)();
  return createMonitoringImplementation((0, _debugLevels.default)('resolve:monitoring-console'), {
    baseMonitoring,
    publishMode
  }, {
    baseMonitoring
  });
};

var _default = createMonitoring;
exports.default = _default;
//# sourceMappingURL=index.js.map